# Deploy

After developing your circuit, you may want to deploy it. However, sharing the details of your circuit with every client might not be desirable. As well as this, you might want to perform the computation on dedicated servers. In this case, you can use the `Client` and `Server` features of **Concrete**.

## Development of the circuit

You can develop your circuit using the techniques discussed in previous chapters. Here is a simple example:

```python
from concrete import fhe

@fhe.compiler({"x": "encrypted"})
def function(x):
    return x + 42

inputset = range(10)
circuit = function.compile(inputset)
```

Once you have your circuit, you can save everything the server needs:

```python
circuit.server.save("server.zip")
```

Then, send `server.zip` to your computation server.

## Setting up a server

You can load the `server.zip` you get from the development machine:

```python
from concrete import fhe

server = fhe.Server.load("server.zip")
```

You will need to wait for requests from clients. The first likely request is for `ClientSpecs`.

Clients need `ClientSpecs` to generate keys and request computation. You can serialize `ClientSpecs`:

```python
serialized_client_specs: str = server.client_specs.serialize()
```

Then, you can send it to the clients requesting it.

## Setting up clients

After getting the serialized `ClientSpecs` from a server, you can create the client object:

```python
client_specs = fhe.ClientSpecs.deserialize(serialized_client_specs)
client = fhe.Client(client_specs)
```

## Generating keys (on the client)

Once you have the `Client` object, you can perform key generation:

```python
client.keys.generate()
```

This method generates encryption/decryption keys and evaluation keys.

The server needs access to the evaluation keys that were just generated. You can serialize your evaluation keys as shown:

```python
serialized_evaluation_keys: bytes = client.evaluation_keys.serialize()
```

After serialization, send the evaluation keys to the server.

{% hint style="info" %}
Serialized evaluation keys are very large, so you may want to cache them on the server instead of sending them with each request.
{% endhint %}

## Encrypting inputs (on the client)

The next step is to encrypt your inputs and request the server to perform some computation. This can be done in the following way:

```python
arg: fhe.Value = client.encrypt(7)
serialized_arg: bytes = arg.serialize()
```

Then, send the serialized arguments to the server.

## Performing computation (on the server)

Once you have serialized evaluation keys and serialized arguments, you can deserialize them:

```python
deserialized_evaluation_keys = fhe.EvaluationKeys.deserialize(serialized_evaluation_keys)
deserialized_arg = fhe.Value.deserialize(serialized_arg)
```

You can perform the computation, as well:

```python
result: fhe.Value = server.run(deserialized_arg, evaluation_keys=deserialized_evaluation_keys)
serialized_result: bytes = result.serialize()
```

Then, send the serialized result back to the client. After this, the client can decrypt to receive the result of the computation.

## Decrypting the result (on the client)

Once you have received the serialized result of the computation from the server, you can deserialize it:

```python
deserialized_result = fhe.Value.deserialize(serialized_result)
```

Then, decrypt the result:

```python
decrypted_result = client.decrypt(deserialized_result)
assert decrypted_result == 49
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zama.org/concrete/2.4/how-to/deploy.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
